#include <stdio.h>
#include <stdlib.h>
#include <sysexits.h>

size_t  read_list(double **list);
void    print_list(double *list_ptr,size_t list_size);

int     main()

{
    size_t  list_size;
    double  *list;
    
    list_size = read_list(&list);
    print_list(list,list_size);
    free(list);
    return 0;
}

/*
 * Allocate memory for a list and read in the values
 */
 
size_t  read_list(double **list)

{
    int     ch;
    unsigned long   list_size;
    double  *temp, *p;  /* Use temp in place of */
			/* *list to simplify code */
    
    /* Get size of list */
    scanf("%lu",&list_size);
    do
    {
	temp = (double *)malloc(list_size * sizeof(*temp));
	if ( temp == NULL )
	{
	    puts("Out of memory.  Try again? (y/n) ");
	    if ( (ch = getchar()) == 'n' )
		exit(EX_OSERR);
	}
    }   while ( (temp == NULL) && (ch == 'y') );

    /* Read until EOF encountered or array is full */
    for (p=temp; p<temp+list_size; ++p)
	scanf("%lf",p);

    *list = temp;       /* Return pointer to list */
    return list_size;    /* Return list size */
}


void    print_list(double *list_ptr,size_t list_size)

{
    /* Compute address of end of list */
    double  *end_ptr = list_ptr + list_size;
    
    while ( list_ptr < end_ptr )
	printf("%f\n",*list_ptr++);
    return;
}

