#include <iostream.h>
#include <sysexits.h>

#define MAX_STUDS       20
#define MAX_NAME_LEN    40

// Generic person class for use as a subtype
class person
{
    public:
    
	// Fields in person should be initialized here
	// not redundantly in derived classes
	person(void)
	{
	    *first_name = *last_name = '\0';
	}

    // Data members inherited by derived classes
    protected:
	char    first_name[MAX_NAME_LEN+1];
	char    last_name[MAX_NAME_LEN+1];
	int     age;
};


// Professor class derived from generic person
class faculty : public person
{
    public:
	void    input(void);
	void    output(void);
    
    private:    // Info unique to faculty
	double  salary;
	double  research_grants;
};


// Input faculty information from standard input

void faculty :: input(void)

{
    cout << "First name? ";
    cin >> first_name;
    cout << "Last name? ";
    cin >> last_name;
    cout << "Salary? ";
    cin >> salary;
    cout << "Grant money? ";
    cin >> research_grants;
}


// Print faculty info to standard output

void faculty :: output(void)

{
    cout << "First name: " << first_name << endl;
    cout << "Last name: " << last_name << endl;
    cout << "Salary: " << salary << endl;
    cout << "Grant money: " << research_grants << endl;
}


// Student class derived from generic person

class student : public person
{
    public:
	void    input(void);
	void    output(void);

    private:    // Info unique to students
	double  tuition;
};


int     main(int argc,char *argv[])

{
    faculty professor;

    // Input and output info on a professor
    professor.input();
    professor.output();
    return EX_OK;
}

