#include <stdio.h>

#define MAX_FUNCTIONS   100

/* Type name for pointer to void function */
typedef void (*funcptr)(double,double);

/* Prototypes */
void    init_tab(funcptr []);
void    add(double,double);
void    subtract(double,double);
void    multiply(double,double);

int     main()
{
    /* Array of pointers to void functions */
    funcptr table[MAX_FUNCTIONS];
    
    unsigned char    op;
    double  a,b;
    
    /* Initialize pointer table */
    init_tab(table);
    
    printf("Enter expression: ");
    scanf("%lf %c %lf",&a,&op,&b);
    if ( (op < MAX_FUNCTIONS) && (table[(int)op] != NULL) )
	(*table[(int)op])(a,b);
    else
	fprintf(stderr,"Invalid operator: %c\n",op);
    return 0;
}


void    init_tab(funcptr table[])

{
    int     c;
    
    /* NULL all entries */
    for (c=0; c<MAX_FUNCTIONS; ++c)
	table[c] = NULL;
    
    /* Set valid entries */
    table['+'] = add;
    table['-'] = subtract;
    table['*'] = multiply;
}


void    add(double a, double b)

{
    printf("The sum is %f.\n",a+b);
}


void    subtract(double a, double b)

{
    printf("The difference is %f.\n",a-b);
}


void    multiply(double a, double b)

{
    printf("The product is %f.\n",a*b);
}

