#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#define BLOCK_SIZE  40

int     main(int argc,char *argv[])

{
    static char    *buff;
    int     shmid,
	    mode = SHM_R|SHM_W;
    
    /* Create shared memory object */
    if ( (shmid=shmget(IPC_PRIVATE,
		       BLOCK_SIZE,mode)) == -1 )
	perror("shmget() failed");
    
    /* Map object into this process' memory space */
    if ( (void *)(buff = shmat(shmid,0,0)) == (void *)-1 )
	perror("shmat() failed");

    /* Create second process to share memory with */
    if ( fork() != 0 )
    {
	/* Write message to shared memory */
	strcpy(buff,"Hello, clone!");
	printf("Writer has: %s\n",buff);
	
	/* Detach shared memory from process */
	shmdt(buff);
    }
    else
    {
	/* Allow writer time to write message */
	sleep(1);
	
	/* Print message stored in shared memory */
	printf("Reader has: %s\n",buff);
	
	/* Detach shared memory from process */
	shmdt(buff);
	
	/* Delete shared memory object from system */
	shmctl(shmid,IPC_RMID,NULL);
    }
    return 0;
}

