
/* SunOS Compile: cc prog -lsocket */
/* SCO_SV Compile: cc -v prog -lsocket */

/*
 * connect.c
 */

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>

#define BUFF_SIZE   40

int     main(int argc,char *argv[])

{
    /* Writer */
    int     s, namelen=14;
#if defined(FreeBSD) || defined(Darwin)
    struct sockaddr myname = {4,AF_UNIX, "Barny"},
		    name = {4,AF_UNIX, "Fred"};
#else
    struct sockaddr myname = {AF_UNIX, "Barny"},
		    name = {AF_UNIX, "Fred"};
#endif

    /* Create socket */
    s = socket(AF_UNIX,SOCK_STREAM,0);
    if ( s == -1 )
	perror("socket() failed.");
    
    /* Name socket so Fred knows who's calling */
    if ( bind(s,&myname,namelen) == -1 )
	perror("bind() failed in child");
    
    /* Connect to socket "Fred" in other process */
    if ( (connect(s,&name,namelen)) == -1 )
	perror("connect() failed");
    
    /* Send message, including nul terminator */
    printf("connect: Wrote %ld bytes.\n",
	    (long)write(s,"Hello!",7));
    close(s);
    unlink("Barny");
    return 0;
}

