
/* SunOS Compile: cc prog -lsocket -lnsl */
/* SCO_SV Compile: cc -v prog -lsocket */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#define NAME_LEN    80

void    getline(char *string,int array_size);

int     main(int argc,char *argv[])

{
    /* Internet socket address */
    struct sockaddr_in  sin;
    
    /* Host information structure */
    struct hostent      *host_ent;
    
    /* File descriptor for socket */
    int     s;
    char    hostname[NAME_LEN+1];
    
    /* Specify Internet address */
    sin.sin_family = AF_INET;
    
    /* Get ftp hostname */
    fputs("Enter the host name of the ftp server: ",
	    stdout);
    getline(hostname,NAME_LEN);

    /* Get host address from name */
    host_ent = gethostbyname(hostname);
    
    /* Copy address to sockaddr_in structure */
    memcpy(&sin.sin_addr,host_ent->h_addr,
	    host_ent->h_length);
    printf("Name: %s Address type: %d Length: %d",
	    host_ent->h_name,host_ent->h_addrtype,
	    host_ent->h_length);
    printf("Address: %lX\nAlias: %s\n",
	    (unsigned long)sin.sin_addr.s_addr,
	    host_ent->h_aliases[0]);
    
    /* Alternatively, get address from numeric
       address string If you know the numeric
       equivalent of your server's host name,
       type it in place of the address below.
	
	sin.sin_addr.s_addr = inet_addr("0.0.0.0");
	printf("s_addr = %lX\n",sin.sin_addr.s_addr);*/
    
    /* Port 21 is for ftp server, which should be
       listening.  This host may be big-endian or
       little-endian, and all communication over the
       network must use the same standard.  htons()
       will make sure the port number is transmitted
       in the right byte order for the Internet. */
    sin.sin_port = htons(21);
    
    /* Create socket */
    if ( (s = socket(AF_INET,SOCK_STREAM,0)) == -1 )
	perror("socket() failed");
    
    /* Connect to ftp server */
    if ( connect(s,(struct sockaddr *)&sin,
		sizeof(sin)) == -1 )
	perror("connect() failed");
    else
	printf("Connection established!\n");
    
    /* Perform ftp transactions ... */
    
    return 0;
}


/*
 * This function should be in a library, but the code is
 * inserted here for clarity.  Input a string, and null
 * terminate 
 */
 
void    getline(char *string,int array_size)

{
    /* Read up to newline or to array limit */
    while ( ((*string = getchar()) != '\n') &&
	    (--array_size > 0) )
	++string;
    *string = '\0';   /* null terminate */
}

