
/* SunOS Compile: cc prog -lsocket */
/* SCO_SV Compile: cc -v prog -lsocket */

/*
 * listen.c
 */
 
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>

#define BUFF_SIZE   40

int     main(int argc,char *argv[])

{
    char    buff[BUFF_SIZE+1];

    /* Reader */
    int         s, s2;
    socklen_t   namelen = 14, peernamelen = 14;

#if defined(FreeBSD) || defined(Darwin)
    struct sockaddr name = {4,AF_UNIX,"Fred"},
		    peername = {14,AF_UNIX,""};
#else
    struct sockaddr name = {AF_UNIX,"Fred"},
		    peername = {AF_UNIX,""};
#endif

    /* Create socket */
    s = socket(AF_UNIX,SOCK_STREAM,0);
    if ( s == -1 )
	perror("socket() failed");
    
    /* Name the new socket so others can connect */
    if ( bind(s,&name,namelen) == -1 )
	perror("bind() failed in parent");
    
    /* Listen and accept a connection request */
    if ( listen(s,1) == -1 )
	perror("listen() failed");
    s2 = accept(s,&peername,&peernamelen);
    if ( s2 == -1 )
	perror("accept() failed");
    else
	printf("listen: Accepted connect from %s.\n",
		peername.sa_data);
    
    /* Read message from socket */
    printf("listen: Read %ld bytes.\n",
	    (long)read(s2,buff,BUFF_SIZE));
    printf("listen: Got a message from %s: %s\n",
	    peername.sa_data,buff);
    
    /* Clean up */
    close(s);
    close(s2);
    unlink("Fred");
    return 0;
}

