#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <fcntl.h>
/* Place sysexits after unistd to work around a bug in IRIX.  EX_OK
   is defined differently in these two headers, and we want the
   sysexists version to override here */
#include <sysexits.h>

/* 64k buffer will mean few read and write calls */
#define BUFF_SIZE   65536

int     main(int argc,char *argv[])

{
    char    buff[BUFF_SIZE+1];
    int     infd;
    size_t  bytes;
    
    switch(argc)
    {
	case    1:  /* Used as filter */
	    infd = fileno(stdin);
	    break;
	case    2:  /* Open the given filename */
	    infd = open(argv[1],O_RDONLY);
	    if ( infd == -1 )
	    {
		fprintf(stderr,
			"Could not open file: %s\n",
			argv[1]);
		return EX_NOINPUT;
	    }
	    break;
	default:
	    fprintf(stderr,"Usage: %s [file]\n",
		    argv[0]);
	    return EX_USAGE;
    }
    
    /* Read and write 64k blocks */
    while ( (bytes=read(infd,buff,BUFF_SIZE)) != 0 )
	write(fileno(stdout),buff,bytes);
    close(infd);
    return EX_OK;
}

