#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

int     catfile(char *filename);

int     main(int argc,char *argv[])

{
    switch(argc)
    {
	case    2:
	    catfile(argv[1]);
	    break;
	default:
	    fprintf(stderr,"Usage: %s <file>\n",argv[0]);
	    return 1;
    }
    return 0;
}


int     catfile(char *filename)

{
    struct stat fileinfo;
    int         fd,bytes;
    long        buffsize;
    char        *buff;
    
    /* Open file */
    if ( (fd = open(filename,O_RDONLY)) == -1 )
    {
	fprintf(stderr,"Cannot open %s.\n",filename);
	return -1;
    }
    
    /* Determine block size and create buffer */
    fstat(fd,&fileinfo);
    buffsize = fileinfo.st_blksize;
    buff = malloc(buffsize);
    
    /* Display file */
    while ( (bytes = read(fd,buff,buffsize)) > 0 )
	write(fileno(stdout),buff,bytes);
    close(fd);
    free(buff);
    return bytes;
}

