#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/wait.h>

#define COMMAND_LEN 255
#define MAX_ARGS    1024
#define STAT_MAX    20

enum {FALSE, TRUE};

int     main(int argc,char *argv[], char *envp[])

{
    char    cmd[COMMAND_LEN+1],
	    *new_argv[MAX_ARGS],
	    *path;
    int     c,
	    status;
    
    /* Input commands until "exit" is entered */
    do
    {
	fputs("Skel-shell: ",stdout);
	fgets(cmd,COMMAND_LEN,stdin);
	
	/* Set up argv array for execvp */
	path = new_argv[0] = strtok(cmd," \t\n");
	for (c=1; (new_argv[c] = strtok(NULL," \t\n")) 
		   != NULL; ++c)
	    ;

	/* If it's an external command, fork */
	if ( strcmp(path,"exit") != 0 )
	{
	    /* Create child process */
	    if ( fork() == 0 )
	    {
		/* If child, run command */
		execvp(path,new_argv);
		
		/* Error: kill child */
		perror(cmd);
		exit(1);
	    }
	    else
	    {
		/* If parent, wait for child */
		wait(&status);
	    }
	}
    }   while ( strcmp(cmd,"exit") != 0 );
    return 0;
}

