#include <stdio.h>
#include <sysexits.h>

#define NO_LIST -1
#define MAX_LIST_SIZE   1000

/* Flexible floating point type */
typedef double float_t;

/* Prototypes */
void    print_list(float_t list[],size_t list_size);
void    sort_list(float_t list[],size_t list_size);
size_t  read_list(char *pathname,float_t list[],
		  size_t list_size);

/*
 * Read numbers from a file, sort, and print the
 * sorted list to stdout.
 */
 
int     main(int argc,char *argv[])

{
    size_t  list_size;
    float_t  list[MAX_LIST_SIZE];
    
    list_size = read_list("input",list,MAX_LIST_SIZE);
    if ( list_size != NO_LIST )
    {
	sort_list(list,list_size);
	print_list(list,list_size);
    }
    return EX_OK;
}

/*
 * Open the specified file and read values until end
 * of file, placing each value in list.
 */
 
size_t  read_list(char *pathname,float_t list[],
		  size_t max_list_size)

{
    FILE    *infile;
    size_t  c = 0;
    
    /* Attempt to open file */
    infile = fopen(pathname,"r");
    if ( infile == NULL )
    {
	fprintf(stderr,
		"Cannot open \"%s\".\n",pathname);
	return NO_LIST;
    }
    
    /* Read until array is full or end od file */
    while ( (c < max_list_size) &&
	    (fscanf(infile,"%lf",list+c) == 1) )
	++c;
    
    fclose(infile);
    return c;
}


void    print_list(float_t list[],size_t list_size)

{
}

void    sort_list(float_t list[],size_t list_size)

{
}

