#include <stdio.h>
#include <sysexits.h>
#include <sys/types.h>
#include <regex.h>

#define MAX_RE_LEN      40
#define MAX_STRING_LEN  80
#define MAX_ERR_LEN     80

int     main(int argc,char *argv[])

{
    char    regex[MAX_RE_LEN+1],
	    string[MAX_STRING_LEN+1],
	    error[MAX_ERR_LEN+1];
    int     comp_code, exec_code;
    regex_t preg;
    regmatch_t  match[1];

    /* Get regular expression and string to test */
    fputs("Enter expression: ",stdout);
    fgets(regex,MAX_RE_LEN,stdin);
    fputs("Enter string: ",stdout);
    fgets(string,MAX_STRING_LEN,stdin);
    
    /* Compile regular expression */
    comp_code = regcomp(&preg,regex,
			REG_EXTENDED|REG_ICASE);
    if ( comp_code != 0 )
    {
	regerror(comp_code, &preg, error, MAX_ERR_LEN);
	fprintf(stderr,"Error compiling RE: %s\n",
		error);
	return comp_code;
    }
    
    /* Search string for regular expression */
    exec_code = regexec(&preg,string,1,match,0);
    /* Match */
    if ( exec_code == 0 )
    {
	printf("Match found at character %lu.\n",
		(unsigned long)match[0].rm_so);
    }
    /* No match */
    else if ( exec_code == REG_NOMATCH )
    {
	printf("No match.\n");
    }
    /* Error in regexec */
    else
    {
	regerror(comp_code, &preg, error, MAX_ERR_LEN);
	fprintf(stderr,"Error executing RE: %s\n",
		error);
	return exec_code;
    }
    return EX_OK;
}

