#include <stdio.h>
#include <sysexits.h>

#define MAX_NAME_LEN    40

/* Player structure */
typedef struct
{
    int     world_rank;
    char    first_name[MAX_NAME_LEN+1];
    char    last_name[MAX_NAME_LEN+1];
}   player_t;

/* Prototypes of player_t member functions */
void    read_player(player_t *ptr);
void    print_player(const player_t *ptr);

/* Prototypes of non-member functions */
void    getline(char string[],int maxlen);


int     main()

{
    player_t    player;
    
    read_player(&player);
    print_player(&player);
    return EX_OK;
}


/****************************************
 * Read a player's info into a structure
 ****************************************/

void    read_player(player_t *ptr)

{
    /* Input name */
    fputs("First name? ",stdout);
    getline(ptr->first_name,MAX_NAME_LEN);
    fputs("Last name? ",stdout);
    getline(ptr->last_name,MAX_NAME_LEN);
    
    /* Input ranking information */
    fputs("World rank? ",stdout);
    scanf("%d",&ptr->world_rank);
}


/**********************************
 * Print a player's info to stdout
 **********************************/
 
void    print_player(const player_t *ptr)

{
    printf("Name: %s %s   World rank: %d\n",
	    ptr->first_name,ptr->last_name,
	    ptr->world_rank);
}


/*************************************
 * Input a string, and null terminate
 *************************************/

void    getline(char string[],int maxlen)

{
    size_t  c = 0;

    /* Read up to newline or to array limit */
    while ( ((string[c] = getchar()) != '\n') &&
	    (c < maxlen-1) )
	++c;
    string[c] = '\0';   /* null terminate */
}

